package nl.amis.email;

import java.util.Date;
import java.util.Properties;

import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;


public class EmailSender {
  private static void log(String msg) {
      result = result + ";" + msg;
  }
  private static String result = "start;";


    public static String send(String from, String to, String cc, String bcc,
                           String subject, String body, String SMTPHost) {

        {
            int rc = 0;

            try {
                Properties props = System.getProperties();
                props.put("mail.smtp.host", SMTPHost);
log("props");
                Message msg =
                    new MimeMessage(Session.getDefaultInstance(props, null));


                msg.setFrom(new InternetAddress(from));
                log("from");

                if (to != null && to.length() > 0)
                    msg.setRecipients(Message.RecipientType.TO,
                                      InternetAddress.parse(to, false));
log("to");
                if (cc != null && cc.length() > 0)
                    msg.setRecipients(Message.RecipientType.CC,
                                      InternetAddress.parse(cc, false));

                if (bcc != null && bcc.length() > 0)
                    msg.setRecipients(Message.RecipientType.BCC,
                                      InternetAddress.parse(bcc, false));

                if (subject != null && subject.length() > 0)
                    msg.setSubject(subject);
                else
                    msg.setSubject("(no subject)");

                msg.setSentDate(new Date());

                msg.setText((body != null ? body : ""));
                log("go send");
                Transport.send(msg);
                rc = 1;
            } catch (Exception e) {
                log(e.getMessage());
                e.printStackTrace();
                rc = 0;
            } finally {
                return result;
            }
        }
    }

    public static void main(String[] args) {
        String from = "maggie@stmatthews.com";
        String to = "frank@stmatthews.com";
        String cc = "";
        String bcc = "";
        String subject = "My Reply";
        String body = "Some content";
        String SMTPHost = "localhost";
        String r  =EmailSender.send(from, to, cc, bcc, subject, body, SMTPHost);
                  System.out.println(r);
    }
}
