package nl.amis.hrm.model;

import java.util.List;

import javax.ejb.Local;

@Local
public interface HrmSessionEJBLocal {
    Object queryByRange(String jpqlStmt, int firstResult, int maxResults);

    Employee persistEmployee(Employee employee);

    Employee mergeEmployee(Employee employee);

    void removeEmployee(Employee employee);

    List<Employee> getEmployeeFindAll();

    Department persistDepartment(Department department);

    Department mergeDepartment(Department department);

    void removeDepartment(Department department);

    List<Department> getDepartmentFindAll();
}
