set feedback on
set echo on
set linesize 150

cl scr

select emp.*
     , dept.dname
  from emp as of timestamp (systimestamp - interval '1' hour) 
     , dept
 where emp.deptno = dept.deptno


 
 select ename, sal
  from emp versions between timestamp systimestamp - 5/60/24 and systimestamp

  
  select ename, sal,
       versions_operation,
       versions_starttime,
       versions_endtime,
       versions_startscn,
       versions_endscn,
       versions_xid
  from emp versions between timestamp minvalue and maxvalue
 where empno = 7788
 order by versions_startscn nulls first
/

select xid
,      start_scn
,      commit_scn
,      operation
,      undo_sql
,      table_name 
from   flashback_transaction_query
where  xid = '&transactionId'
/


rem biggest salary raise ever

select *
from   ( select empno
         ,      ename
		 ,      versions_starttime
		 ,      sal - lead(sal) over ( partition by empno
		                               order by versions_starttime
                                                desc nulls last									   
								     ) salary_raise
         from   emp versions between timestamp minvalue and maxvalue
         order
         by     salary_raise desc nulls last
        )
where   rownum = 1

		
execute dbms_flashback.enable_at_time (TO_TIMESTAMP('16-12-2010 14:35', 'DD-MM-YYYY HH24:MI'));


		