set feedback on
set echo on
set linesize 150

cl scr


prompt Get number of Employees in Job Per Department

select *
from (select job
      ,      deptno
      from emp
     ) 
order by job, deptno

pause

/

pause

select *
from (select job
      ,      deptno
      from emp
     ) pivot ( count(*) count_staff
             for deptno in (10, 20, 30)                             
             )

pause

/

pause

prompt throw in a cell with the salary sum
select *
from (select job
      ,      deptno
      ,      sal
      from emp
     ) pivot ( count(*) count_staff
             , sum(sal) salsum
             for deptno in (10, 20, 30)                             
             )

pause

/

pause


select *
from (select job
      ,      deptno
      from emp
     ) pivot xml ( count(*) count_staff
                   for deptno in (ANY)                             
                 )
/


select *
from  xmltable('for $i in ora:view("SCOTT", "EMP" )/ROW 
                where $i/JOB = "MANAGER"
                return ($i/ENAME,$i/SAL,$i/HIREDATE)' 
                COLUMNS
                  PIVOT_COLUMN varchar2(20) path '/'
               )
/

